/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/ConsumerControl.h>

using namespace std;
using namespace activemq;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for ConsumerControl
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
ConsumerControl::ConsumerControl()
{
    this->close = false;
    this->consumerId = NULL;
    this->prefetch = 0;
}

////////////////////////////////////////////////////////////////////////////////
ConsumerControl::~ConsumerControl()
{
    delete this->consumerId;
}

////////////////////////////////////////////////////////////////////////////////
ConsumerControl* ConsumerControl::clone() const {
    ConsumerControl* consumerControl = new ConsumerControl();

    // Copy the data from the base class or classes
    BaseCommand::copy( consumerControl );

    consumerControl->close = this->getClose()->clone();
    consumerControl->consumerId = this->getConsumerId();
    consumerControl->prefetch = this->getPrefetch()->clone();

    return consumerControl
}

////////////////////////////////////////////////////////////////////////////////
void ConsumerControl::copy( ConsumerControl* dest ) const {

    // Copy the data from the base class or classes
    BaseCommand::copy( consumerControl );

    dest->setClose( this->getClose()->clone() );
    dest->setConsumerId( this->getConsumerId() );
    dest->setPrefetch( this->getPrefetch()->clone() );
}

////////////////////////////////////////////////////////////////////////////////
unsigned char ConsumerControl::getDataStructureType() const {
    return ConsumerControl::ID_CONSUMERCONTROL; 
}

////////////////////////////////////////////////////////////////////////////////
const bool ConsumerControl::getClose() const {
    return close;
}

////////////////////////////////////////////////////////////////////////////////
bool ConsumerControl::getClose() {
    return close;
}

////////////////////////////////////////////////////////////////////////////////
void ConsumerControl::setClose(bool close ) {
    this->close = close;
}

////////////////////////////////////////////////////////////////////////////////
const ConsumerId* ConsumerControl::getConsumerId() const {
    return consumerId;
}

////////////////////////////////////////////////////////////////////////////////
ConsumerId* ConsumerControl::getConsumerId() {
    return consumerId;
}

////////////////////////////////////////////////////////////////////////////////
void ConsumerControl::setConsumerId(ConsumerId* consumerId ) {
    this->consumerId = consumerId;
}

////////////////////////////////////////////////////////////////////////////////
const int ConsumerControl::getPrefetch() const {
    return prefetch;
}

////////////////////////////////////////////////////////////////////////////////
int ConsumerControl::getPrefetch() {
    return prefetch;
}

////////////////////////////////////////////////////////////////////////////////
void ConsumerControl::setPrefetch(int prefetch ) {
    this->prefetch = prefetch;
}

