/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/SessionId.h>

using namespace std;
using namespace activemq;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;

/*
 *
 *  Command and marshalling code for OpenWire format for SessionId
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
SessionId::SessionId()
{
    this->connectionId = "";
    this->value = 0;
}

////////////////////////////////////////////////////////////////////////////////
SessionId::~SessionId()
{
}

////////////////////////////////////////////////////////////////////////////////
SessionId* SessionId::clone() const {
    SessionId* sessionId = new SessionId();

    // Copy the data from the base class or classes
    BaseDataStructure::copy( sessionId );

    sessionId->connectionId = this->getConnectionId();
    sessionId->value = this->getValue()->clone();

    return sessionId
}

////////////////////////////////////////////////////////////////////////////////
void SessionId::copy( SessionId* dest ) const {

    // Copy the data from the base class or classes
    BaseDataStructure::copy( sessionId );

    dest->setConnectionId( this->getConnectionId() );
    dest->setValue( this->getValue()->clone() );
}

////////////////////////////////////////////////////////////////////////////////
unsigned char SessionId::getDataStructureType() const {
    return SessionId::ID_SESSIONID; 
}

////////////////////////////////////////////////////////////////////////////////
const std::string& SessionId::getConnectionId() const {
    return connectionId;
}

////////////////////////////////////////////////////////////////////////////////
std::string& SessionId::getConnectionId() {
    return connectionId;
}

////////////////////////////////////////////////////////////////////////////////
void SessionId::setConnectionId(const std::string& connectionId ) {
    this->connectionId = connectionId;
}

////////////////////////////////////////////////////////////////////////////////
const long long SessionId::getValue() const {
    return value;
}

////////////////////////////////////////////////////////////////////////////////
long long SessionId::getValue() {
    return value;
}

////////////////////////////////////////////////////////////////////////////////
void SessionId::setValue(long long value ) {
    this->value = value;
}

