/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/ActiveMQMessageMarshaller.h>

#include <activemq/connector/openwire/commands/ActiveMQMessage.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* ActiveMQMessageMarshaller::createObject() const {
    return new ActiveMQMessage();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char ActiveMQMessageMarshaller::getDataStructureType() const {
    return ActiveMQMessage::ID_ACTIVEMQMESSAGE;
}

///////////////////////////////////////////////////////////////////////////////
void ActiveMQMessageMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   MessageMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    ActiveMQMessage* info =
        dynamic_cast<ActiveMQMessage*>( dataStructure );
    info->beforeUnmarshall( wireFormat );


    info->afterUnmarshall( wireFormat );
}

///////////////////////////////////////////////////////////////////////////////
int ActiveMQMessageMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    info->beforeMarshall( wireFormat );
    int rc = MessageMarshaller::tightMarshal1( wireFormat, dataStructure, bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void ActiveMQMessageMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    MessageMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    ActiveMQMessage* info =
        dynamic_cast<ActiveMQMessage*>( dataStructure );
    info->afterMarshall( wireFormat );
}

///////////////////////////////////////////////////////////////////////////////
void ActiveMQMessageMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    MessageMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    ActiveMQMessage* info = 
        dynamic_cast<ActiveMQMessage*>( dataStructure );
    info->beforeUnmarshall( wireFormat );
    info->afterUnmarshall( wireFormat );
}

///////////////////////////////////////////////////////////////////////////////
void ActiveMQMessageMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    ActiveMQMessage* info =
        dynamic_cast<ActiveMQMessage*>( dataStructure );
    info->beforeMarshall( wireFormat );
    MessageMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    info->afterMarshall( wireFormat );
}

