/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/DataResponseMarshaller.h>

#include <activemq/connector/openwire/commands/DataResponse.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* DataResponseMarshaller::createObject() const {
    return new DataResponse();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char DataResponseMarshaller::getDataStructureType() const {
    return DataResponse::ID_DATARESPONSE;
}

///////////////////////////////////////////////////////////////////////////////
void DataResponseMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   ResponseMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    DataResponse* info =
        dynamic_cast<DataResponse*>( dataStructure );
    info->setData( dynamic_cast< DataStructure* >(
        tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
}

///////////////////////////////////////////////////////////////////////////////
int DataResponseMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    DataResponse* info =
        dynamic_cast<DataResponse*>( dataStructure );

    int rc = ResponseMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getData() );

    rc += tightMarshalNestedObject1( wireFormat, data, bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void DataResponseMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    ResponseMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    DataResponse* info =
        dynamic_cast<DataResponse*>( dataStructure );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getData() );

    tightMarshalNestedObject2( wireFormat, data, dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void DataResponseMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    ResponseMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    DataResponse* info = 
        dynamic_cast<DataResponse*>( dataStructure );
   info->setData( dynamic_cast<DataStructure* >( 
       looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
}

///////////////////////////////////////////////////////////////////////////////
void DataResponseMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    DataResponse* info =
        dynamic_cast<DataResponse*>( dataStructure );
    ResponseMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getData() );

    looseMarshalNestedObject( wireFormat, data, dataOut );
}

