/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/MessageAckMarshaller.h>

#include <activemq/connector/openwire/commands/MessageAck.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* MessageAckMarshaller::createObject() const {
    return new MessageAck();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char MessageAckMarshaller::getDataStructureType() const {
    return MessageAck::ID_MESSAGEACK;
}

///////////////////////////////////////////////////////////////////////////////
void MessageAckMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   BaseCommandMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    MessageAck* info =
        dynamic_cast<MessageAck*>( dataStructure );
    info->setDestination( dynamic_cast< ActiveMQDestination* >(
        tightUnmarsalCachedObject( wireFormat, dataIn, bs ) );
    info->setTransactionId( dynamic_cast< TransactionId* >(
        tightUnmarsalCachedObject( wireFormat, dataIn, bs ) );
    info->setConsumerId( dynamic_cast< ConsumerId* >(
        tightUnmarsalCachedObject( wireFormat, dataIn, bs ) );
    info->setAckType( dataIn->readByte() );
    info->setFirstMessageId( dynamic_cast< MessageId* >(
        tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
    info->setLastMessageId( dynamic_cast< MessageId* >(
        tightUnmarsalNestedObject( wireFormat, dataIn, bs ) );
    info->setMessageCount( dataIn->readInt() );
}

///////////////////////////////////////////////////////////////////////////////
int MessageAckMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    MessageAck* info =
        dynamic_cast<MessageAck*>( dataStructure );

    int rc = BaseCommandMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getDestination() );

    rc += tightMarshalCachedObject1( wireFormat, data, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    rc += tightMarshalCachedObject1( wireFormat, data, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConsumerId() );

    rc += tightMarshalCachedObject1( wireFormat, data, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getFirstMessageId() );

    rc += tightMarshalNestedObject1( wireFormat, data, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getLastMessageId() );

    rc += tightMarshalNestedObject1( wireFormat, data, bs );

    return rc + 5;
}

///////////////////////////////////////////////////////////////////////////////
void MessageAckMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    BaseCommandMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    MessageAck* info =
        dynamic_cast<MessageAck*>( dataStructure );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getDestination() );

    tightMarshalCachedObject2( wireFormat, data, dataOut, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    tightMarshalCachedObject2( wireFormat, data, dataOut, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConsumerId() );

    tightMarshalCachedObject2( wireFormat, data, dataOut, bs );
    dataOut->write( info->getAckType() );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getFirstMessageId() );

    tightMarshalNestedObject2( wireFormat, data, dataOut, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getLastMessageId() );

    tightMarshalNestedObject2( wireFormat, data, dataOut, bs );
    dataOut->write( info->getMessageCount() );
}

///////////////////////////////////////////////////////////////////////////////
void MessageAckMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    BaseCommandMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    MessageAck* info = 
        dynamic_cast<MessageAck*>( dataStructure );
   info->setDestination( dynamic_cast<ActiveMQDestination* >( 
       looseUnmarshalCachedObject( wireFormat, dataIn ) ) );
   info->setTransactionId( dynamic_cast<TransactionId* >( 
       looseUnmarshalCachedObject( wireFormat, dataIn ) ) );
   info->setConsumerId( dynamic_cast<ConsumerId* >( 
       looseUnmarshalCachedObject( wireFormat, dataIn ) ) );
    info->setAckType( dataIn->readByte() );
   info->setFirstMessageId( dynamic_cast<MessageId* >( 
       looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
   info->setLastMessageId( dynamic_cast<MessageId* >( 
       looseUnmarshalNestedObject( wireFormat, dataIn ) ) );
    info->setMessageCount( dataIn->readInt() );
}

///////////////////////////////////////////////////////////////////////////////
void MessageAckMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    MessageAck* info =
        dynamic_cast<MessageAck*>( dataStructure );
    BaseCommandMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getDestination() );

    looseMarshalCachedObject( wireFormat, data, dataOut );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getTransactionId() );

    looseMarshalCachedObject( wireFormat, data, dataOut );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConsumerId() );

    looseMarshalCachedObject( wireFormat, data, dataOut );
    dataOut->write( info->getAckType() );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getFirstMessageId() );

    looseMarshalNestedObject( wireFormat, data, dataOut );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getLastMessageId() );

    looseMarshalNestedObject( wireFormat, data, dataOut );
    dataOut->write( info->getMessageCount() );
}

