/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <activemq/connector/openwire/marshal/v2/RemoveSubscriptionInfoMarshaller.h>

#include <activemq/connector/openwire/commands/RemoveSubscriptionInfo.h>

//
//     NOTE!: This file is autogenerated - do not modify!
//            if you need to make a change, please see the Java Classes in the
//            activemq-core module
//

using namespace std;
using namespace activemq;
using namespace activemq::io;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace activemq::connector::openwire::marshal;
using namespace activemq::connector::openwire::util;
using namespace activemq::connector::openwire::marshal::v2;

///////////////////////////////////////////////////////////////////////////////
DataStructure* RemoveSubscriptionInfoMarshaller::createObject() const {
    return new RemoveSubscriptionInfo();
}

///////////////////////////////////////////////////////////////////////////////
unsigned char RemoveSubscriptionInfoMarshaller::getDataStructureType() const {
    return RemoveSubscriptionInfo::ID_REMOVESUBSCRIPTIONINFO;
}

///////////////////////////////////////////////////////////////////////////////
void RemoveSubscriptionInfoMarshaller::tightUnmarshal( OpenWireFormat* wireFormat, DataStructure* dataStructure, DataInputStream* dataIn, BooleanStream* bs ) {
   BaseCommandMarshaller::tightUnmarshal( wireFormat, dataStructure, dataIn, bs );

    RemoveSubscriptionInfo* info =
        dynamic_cast<RemoveSubscriptionInfo*>( dataStructure );
    info->setConnectionId( dynamic_cast< ConnectionId* >(
        tightUnmarsalCachedObject( wireFormat, dataIn, bs ) );
    info->setSubcriptionName( TightUnmarshalString( dataIn, bs ) );
    info->setClientId( TightUnmarshalString( dataIn, bs ) );
}

///////////////////////////////////////////////////////////////////////////////
int RemoveSubscriptionInfoMarshaller::tightMarshal1( OpenWireFormat& wireFormat, DataStructure* dataStructure, BooleanStream& bs ) {

    RemoveSubscriptionInfo* info =
        dynamic_cast<RemoveSubscriptionInfo*>( dataStructure );

    int rc = BaseCommandMarshaller::tightMarshal1( wireFormat, dataStructure, bs );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConnectionId() );

    rc += tightMarshalCachedObject1( wireFormat, data, bs );
    rc += tightMarshalString1( info->getSubcriptionName(), bs );
    rc += tightMarshalString1( info->getClientId(), bs );

    return rc + 0;
}

///////////////////////////////////////////////////////////////////////////////
void RemoveSubscriptionInfoMarshaller::tightMarshal2( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut, BooleanStream& bs ) {

    BaseCommandMarshaller::tightMarshal2( wireFormat, dataStructure, dataOut, bs );

    RemoveSubscriptionInfo* info =
        dynamic_cast<RemoveSubscriptionInfo*>( dataStructure );
    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConnectionId() );

    tightMarshalCachedObject2( wireFormat, data, dataOut, bs );
    tightMarshalString2( info->getSubcriptionName(), dataOut, bs );
    tightMarshalString2( info->getClientId(), dataOut, bs );
}

///////////////////////////////////////////////////////////////////////////////
void RemoveSubscriptionInfoMarshaller::looseUnmarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataInputStream& dataIn ) {
    BaseCommandMarshaller::looseUnmarshal( wireFormat, dataStructure, dataIn );
    RemoveSubscriptionInfo* info = 
        dynamic_cast<RemoveSubscriptionInfo*>( dataStructure );
   info->setConnectionId( dynamic_cast<ConnectionId* >( 
       looseUnmarshalCachedObject( wireFormat, dataIn ) ) );
    info->setSubcriptionName( looseUnmarshalString( dataIn ) );
    info->setClientId( looseUnmarshalString( dataIn ) );
}

///////////////////////////////////////////////////////////////////////////////
void RemoveSubscriptionInfoMarshaller::looseMarshal( OpenWireFormat& wireFormat, DataStructure* dataStructure, DataOutputStream& dataOut ) {
    RemoveSubscriptionInfo* info =
        dynamic_cast<RemoveSubscriptionInfo*>( dataStructure );
    BaseCommandMarshaller::looseMarshal( wireFormat, dataStructure, dataOut );

    DataStructure* data = 
        dynamic_cast< DataStructure* >( info->getConnectionId() );

    looseMarshalCachedObject( wireFormat, data, dataOut );
    looseMarshalString( info->getSubcriptionName(), dataOut );
    looseMarshalString( info->getClientId(), dataOut );
}

